#ifndef MAIN_H
#define MAIN_H

#include <map>
#include <QObject>
#include <QWidget>
#include <QtWebKit>

class Crawler : public QWidget
{
    Q_OBJECT

    public:
        Crawler(int, QString, QWidget *parent = 0);
        Crawler(QString, QString, QWidget *parent = 0);
        Crawler(QString, QWidget *parent = 0);

    public slots:
        void loadStarted_handler();
        void loadProgress_handler(int);
        void loadFinished_handler(bool);
        void sslErrors_handler(QNetworkReply *, const QList<QSslError> &);
        void checkmarks();
        void errorQuit();

    private:
        bool output;
        enum {UrlId, Assn, Urls} accesstype;
        QString username, password;
        QString regex, assn, questid;
        std::map<QString, QString> id2url;

        QWebView *view;
        QWebPage *page;
        QWebFrame *frame;
        QNetworkAccessManager *network;

        void collectURLs();
        void clickjsid(QString s);

        void initialize();
};

#endif 
